/* SF_Impulse_Generator class declaration
   Copyright (C) 1998--1999 Jarno Seppnen and Sami Kananoja
   $Id: impulse_generator.hh,v 1.3 1999/03/22 11:19:40 jams Exp $

   This file is part of Sonic Flow.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

#ifndef __SF_IMPULSE_GENERATOR_HH__
#define __SF_IMPULSE_GENERATOR_HH__

#include <sf/block.hh>
#include <sf/input_terminal.hh>
#include <sf/output_terminal.hh>

class SF_Impulse_Generator : public SF_Block
{
public:
    SF_Impulse_Generator (const char* name = 0);
    virtual ~SF_Impulse_Generator ();
    virtual void finish ();
    virtual void initialize ();
    virtual void execute ();

protected:
    SF_Sample* s_y;
    bool impulse;

    // Pointers to the input and output terminals; the terminals are addressed
    // through these pointers in the execute () call instead of fetching the
    // pointers by name
    SF_Output_Terminal*	out_y;

private:
    //Disable copy constructor and operator=
    SF_Impulse_Generator (const SF_Impulse_Generator& a);
    SF_Impulse_Generator& operator= (const SF_Impulse_Generator& a);
};

#endif

/* EOF */
